package nxm.gigexd.lib;

import nxm.sys.lib.Shell;

public class Serial {

  // native function definitions
  private static native long alloc ();
  private static native int sendCommand( long hand, String str );
  private static native int setDelay ( long hand, int d );
  private static native int setCarriage ( long hand, int d );
  private static native int setDebug ( long hand, int d);
  private static native int setDevice ( long hand, String str );
  private static native String getStatus ( long hand );
  private static native int free ( long hand );

  /** native handle */
  private long hand;
  /** library loaded */
  private boolean load;

  public Serial () {
    load = Shell.loadLibrary("nxm.gigexd.lib.Serial");
  }

  public boolean init () {
    if ( !load )
      return false;
    // grab the handle
    hand = alloc();
    return ( (hand&0xffffffffL) > 0 ) ? true: false;
  }

  public int setDelay ( int d ) {
    return setDelay(hand, d);
  }

  public int setCarriage ( int d ) {
    return setCarriage(hand, d);
  }

  public int setDebug ( int d ) {
    return setDebug(hand, d);
  }

  public int setDevice ( String str ) {
    return setDevice(hand, str);
  }

  public int sendCommand ( String str ) {
    return sendCommand(hand, str);
  }

  public String getStatus () {
    return getStatus(hand);
  }

  public int close () {
    return free(hand);
  }
}
