startmacro n:inp_freq[1100.0] n:num_rx[4] n:ref_src[1]

switch "OLDDIGI" l:sw_olddigi get -1
if sw_olddigi gt 0 then
  result term_pfx "/dev/tty_dgrp_rp_"
else
  result term_pfx "/dev/ttyrp0"
endif

! common
result str_rst  "*RST"
result str_ref  "REF ^{ref_src}"        
result str_freq "FRQ ^{l_freq}"

! check for chassis 
switch nano nano get false true
if nano isfalse then
  ! chassis
  calc/quiet l:l_freq ^inp_freq 1000 * round

  result str_gain "GAIN 26"
  result str_bwis "BWIS 1"
  ! TODO confirm
  !result str_bwquery "BWIS?"
  result str_gquery "GAIN?"
  result str_bwquery "BWC?"
else
  ! nano
  calc/quiet d:l_freq ^inp_freq 1000 * round 0.001 *

  !... RDH - Changed for new nano BW
  switch "NANO_BW" l:sw_bw get 0 
  if sw_bw le 0 then
    result str_bwis "BWC 6.0"
  else
    result str_bwis "BWC ^{sw_bw}"
  endif

  result str_gain "ATN 40" 
  result str_gquery "ATN?"
  result str_bwquery "BWC?"
endif

loop ^num_rx idx_ob
  calc/quiet/nform="0" idx ^idx_ob 1 -

serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_rst}"  rx_rst
pause/quiet 0.5
serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_ref}"  rx_ref
pause/quiet 0.25
if nano istrue then 
  serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "AGC 0" rx_gain
  pause/quiet 0.25
endif
serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_gain}" rx_gain
pause/quiet 0.25
serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_bwis}" rx_bwis
pause/quiet 0.2
serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_freq}" rx_freq
pause/quiet 0.25

if nano istrue then
  serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "REF?" rx_ref
  serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_gquery}" rx_gain
  serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "^{str_bwquery}" rx_bwis
  serialio/crlf=3/iodelay=250000 "^{term_pfx}^{idx}" "FRQ?" rx_freq
endif

  say "Rx ^{idx} Params:  ^{rx_rst}"
  say "                   ^{rx_ref}" 
  say "                   ^{rx_freq}"
  say "                   ^{rx_gain}"
  say "                   ^{rx_bwis}"

endloop

endmacro
