package nxm.gigexd.prim;

import nxm.sys.lib.Primitive;
import nxm.gigexd.lib.Serial;

public class serialio extends Primitive {

  public int open () {
    String dev = MA.getCS("DEV", null);
    String cmd = MA.getCS("CMD", null);
    String res_str = MA.getU("OUT", "myres");
    MR.put(res_str, "");

    if ( dev==null || cmd == null )
      M.error("Please specify device and command");
    
    // init hand
    Serial ser = new Serial();
    if ( !ser.init() ) 
      M.error("Could not initialize Serial handle");
    // set the debug level
    int debug = MA.getL("/DEBUG", -1);
    ser.setDebug(debug);
    // set the IO delay
    int iodelay = MA.getL("/IODELAY", 0);
    ser.setDelay(iodelay);    
    // set carriage return 
    int car = MA.getL("CRLF", 3);
    ser.setCarriage(car);

    // set the device
    if ( ser.setDevice(dev) < 0 ) {
      ser.close();
      M.error("Trouble setting device: "+dev);
    }
    // send the command
    if ( ser.sendCommand(cmd) < 0 ) {
      ser.close();
      M.error("Trouble sending command: "+cmd);
    }
    // get the status
    String status = ser.getStatus();
    ser.close();

    MR.put(res_str, status);
    return FINISH;
  }

}
